'  run.bas
'  Charles E V Pegge
'  15:35 07/Aug/2007
'  work in progress
'


'for Freebasic compilation:>> fbc $.bas


#define CODEMAX 8191
#define PARAMAX 8191
#define FUNUMAX 1024
'
#define PRIVBASE PARAMAX/2
#define LONGBASE 255
#define LONGVAR LONGBASE+0
#define PRIVAR 254
#define USEFUN 253
#define IFUNS 252
#define FUNBASE 230
#define NLIBS ifuns-FUNBASE-1
#define VARBASE 170
#define IQUOT 169
#define VARMAX FUNBASE-VARBASE-1
#define CMDBASE 128
#define LIBRBUFF 8192

#define DLI 59
#define DUMMY 128

' LIMITS:
' 8K lines of code
' 8K variables either dynamic strings or double precision numbers
' single dimension arrays
' 60   quick local vars for each function ++ slighly slower others
' 256  static vars for each function
' 1024 user functions fast +++ slower
' 256  internal built-in functions
' 21   libraries each 256 functions (2 reserved)
' unlimited local subroutines within +-32k lines
' 64   level function/subroutine stack
' 64   level nesting stack ()
' 64   level block stack {}
'

' Map of internal ByteCodes

' 0 to 9     treated as space (32)
' 10         line feed
' 11 - 12    treated as space (32)
' 13         end of line
' 14-31      treated as space
' 32 to 127  untokenised script content
' 128        dummy argument
' 129 to 168 built in commands and wordy operators
' 169        internal quote mark (like 34 and 39)
' 170 to 230 local variable
' 231 to 251 dll library functions + 1 byte
' 252        built in lunctions + 1 byte
' 253        user defined functions + 1 byte
' 254        private variable + 1 byte
' 255        long addr variable    + 2 bytes

'
' Data space shared with parent and extension libraries:
' VARIABLE ARRAY SETS:
' vaz(8191) names of variables (cas sensitive)
' vsi(8192) status and referencing
' vcz(8191) dynamic string content
' vcd(8191) double precision number content
'
' Using in the parent function
' include "run.inc"
' create an interface table with variables if required
' set next available vars in vcd(31)
' set startup command line in vcz(30) (default load "main.pro"; main()
' completion code @28
' control exec by entaring value in vcd(0)
' 1 EndNow
' 2 PleaseEnd
' 3 Pause
' 4 Continue
' 5 DoLine ...

' NB:
' Ending closes all open files


DIM SHARED libvars AS FUNCTION(siz AS LONG, vsd() AS LONG, vcd() AS DOUBLE, vcz() AS STRING ) AS LONG
DIM SHARED libfuns AS FUNCTION(BYVAL funi AS LONG, BYVAL pai AS LONG) AS LONG
DIM SHARED tfi(NLIBS) AS FUNCTION(BYVAL funi AS LONG, BYVAL pai AS LONG) AS LONG

DECLARE FUNCTION WINMAINS (BYVAL hInstance AS LONG,BYVAL hPrevInstance AS LONG,BYVAL lpCmdLine AS UBYTE PTR,BYVAL iCmdShow AS LONG) AS LONG
DECLARE SUB inserts(BYREF az AS STRING,BYREF bz AS STRING,BYVAL ii AS LONG,BYVAL jj AS LONG)
DECLARE SUB mains (BYVAL hInstance AS LONG)

'---------------------------------------------------------------------------------------------------
'        1         2         3         4         5         6         7         8         9         0
'---------------------------------------------------------------------------------------------------   
DECLARE SUB init()
DECLARE SUB progo()
DECLARE SUB logprint()
DECLARE SUB openin()
DECLARE SUB opens()
DECLARE SUB ddo()
DECLARE SUB searchbegin()
DECLARE SUB denter()
DECLARE SUB dreturn()
DECLARE SUB dfinish()
DECLARE SUB loadprog()
DECLARE SUB toomany()
DECLARE SUB tokenise()
DECLARE SUB tokeval()
DECLARE SUB prynt()
DECLARE SUB words()
DECLARE SUB wordmac()
DECLARE SUB vario()
DECLARE SUB varsearch()
DECLARE SUB srch()
DECLARE SUB loopref()
DECLARE SUB refs()
DECLARE SUB newv()
DECLARE SUB namesplit()
DECLARE SUB errv()
DECLARE SUB notfound()
DECLARE SUB tto()
DECLARE SUB resolvar()
DECLARE SUB expr()
DECLARE SUB expri()
DECLARE SUB condits()
DECLARE SUB analys()
DECLARE SUB libfunction()
DECLARE SUB evarion()
DECLARE SUB varion()
DECLARE SUB clearop()
DECLARE SUB newvar()
DECLARE SUB storeval()
DECLARE SUB donest()
DECLARE SUB unnest()
DECLARE SUB intfun()
DECLARE SUB callufunction()
DECLARE SUB ops()
DECLARE SUB fun()
DECLARE SUB wordsf()
DECLARE SUB atand() ' 360 deg tan
DECLARE SUB erasef()
DECLARE SUB ipa:
DECLARE SUB dpa()
DECLARE SUB errms()
DECLARE SUB seekr()
DECLARE SUB getr()
DECLARE SUB lockr()
DECLARE SUB unlockr()
DECLARE SUB putR()
DECLARE SUB oopen()
DECLARE SUB opn()
DECLARE SUB cloose()


FUNCTION cat2(az AS STRING,bz AS STRING) AS STRING
RETURN az+bz
END FUNCTION

FUNCTION cat3(az AS STRING,bz AS STRING, cz AS STRING) _
 AS STRING
 RETURN az+bz+cz
END FUNCTION

FUNCTION cat4(az AS STRING,bz AS STRING, cz AS STRING,_
 dz AS STRING) AS STRING
 RETURN az+bz+cz+dz
END FUNCTION

SUB inserts(BYREF az AS STRING,BYREF bz AS STRING,_
 BYVAL ii AS LONG,BYVAL jj AS LONG)
 az=cat3(MID$(az,1,ii-1),bz,MID$(az,jj))
END SUB

 'FUNCTION WINMAIN (BYVAL hInstance AS LONG,_
 'BYVAL hPrevInstance AS LONG,BYVAL lpCmdLine AS UBYTE PTR,_
 'BYVAL iCmdShow AS LONG) AS LONG

 DIM hWnd AS LONG
 'DIM Msg AS tagMsg
 DIM aa AS LONG
 DIM hith AS LONG
 DIM AS LONG hInstance
 

'common across modules

 COMMON SHARED vaz() AS STRING
 COMMON SHARED vcz() AS STRING
 COMMON SHARED vcd() AS DOUBLE
 COMMON SHARED vsi() AS LONG
 COMMON SHARED az AS STRING


'dim arrays:

 DIM vaz(PARAMAX)
 DIM vcz(PARAMAX)
 DIM vcd(PARAMAX)
 DIM vsi(PARAMAX)

 DIM SHARED aza(CODEMAX) AS STRING
 DIM SHARED cpi(CODEMAX) AS LONG
 DIM SHARED prgz(63,3) AS STRING
 DIM SHARED prgi(63,8) AS LONG
 DIM SHARED eza(63)  AS STRING
 DIM SHARED ned(63)  AS DOUBLE
 DIM SHARED nez(63,1) AS STRING
 DIM SHARED nei(63,5) AS LONG
 DIM SHARED toto(63) as long
 DIM SHARED whii(63) AS LONG
 DIM SHARED fhii(63) AS LONG
 DIM SHARED blv(63) AS LONG
 DIM SHARED fi(63) AS LONG
 DIM SHARED incli(100,1) AS LONG
 DIM SHARED inclz(100) AS STRING

 DIM SHARED lnki(255,1) AS LONG
 DIM SHARED lnkz(255) AS STRING
 DIM SHARED procz(FUNUMAX,1) AS STRING
 DIM SHARED proci(FUNUMAX,2) AS LONG

 DIM SHARED tpi(NLIBS) AS LONG

'dim scalars

 DIM SHARED aai AS LONG
 DIM SHARED abz AS STRING
 DIM SHARED acz AS STRING
 DIM SHARED accd AS DOUBLE
 DIM SHARED ahi AS LONG
 DIM SHARED ai AS LONG
 DIM SHARED ari AS LONG
 DIM SHARED arz AS STRING
 DIM SHARED atti AS LONG
 DIM SHARED awi AS LONG
 DIM SHARED ayi AS LONG
 ' DIM SHARED az  AS STRING
 DIM SHARED bbi AS LONG
 DIM SHARED bcli AS LONG
 DIM SHARED bcz AS STRING
 DIM SHARED bli AS LONG
 DIM SHARED bi AS LONG
 DIM SHARED blshi AS LONG
 DIM SHARED bsi AS LONG
 DIM SHARED bvi AS LONG
 DIM SHARED bwi AS LONG
 DIM SHARED bz AS STRING
 DIM SHARED charz AS STRING
 DIM SHARED chi AS LONG
 DIM SHARED ci AS LONG
 DIM SHARED cli AS LONG
 DIM SHARED cmd AS LONG
 DIM SHARED cmz AS STRING
 DIM SHARED cnarz AS STRING
 DIM SHARED condi AS LONG
 DIM SHARED crz AS STRING
 DIM SHARED csti AS LONG
 DIM SHARED ctbi AS LONG
 DIM SHARED cti AS LONG
 DIM SHARED cwi AS LONG
 DIM SHARED cz AS STRING
 DIM SHARED dai AS LONG
 DIM SHARED daz AS STRING
 DIM SHARED dez AS STRING
 DIM SHARED dj AS LONG
 DIM SHARED dlmi AS LONG
 DIM SHARED dlxi AS LONG
 DIM SHARED dtrd AS DOUBLE
 DIM SHARED dz AS STRING
 DIM SHARED efi AS LONG
 DIM SHARED ei AS LONG
 DIM SHARED erci AS LONG
 DIM SHARED erfi AS LONG
 DIM SHARED eri AS LONG
 DIM SHARED ermx AS LONG
 DIM SHARED ez AS STRING
 DIM SHARED fbi  AS LONG
 DIM SHARED fci AS LONG
 DIM SHARED ffz AS STRING
 DIM SHARED fhi AS LONG
 DIM SHARED fpi AS LONG
 DIM SHARED fti AS LONG
 DIM SHARED funi AS LONG
 DIM SHARED fvi AS LONG
 DIM SHARED fyni AS LONG
 DIM SHARED fz AS STRING
 DIM SHARED gi AS LONG
 DIM SHARED gm1 AS LONG
 DIM SHARED gm2 AS LONG
 DIM SHARED gm3 AS LONG
 DIM SHARED gm4 AS LONG
 DIM SHARED gz AS STRING
 DIM SHARED hLib    AS LONG
 DIM SHARED hai AS LONG
 DIM SHARED haz AS STRING
 DIM SHARED hbi AS LONG
 DIM SHARED hbz AS STRING
 DIM SHARED ici AS LONG
 DIM SHARED ii AS LONG
 DIM SHARED infi AS LONG
 DIM SHARED inlz AS STRING
 DIM SHARED ioi AS LONG
 DIM SHARED ip AS UBYTE POINTER
 DIM SHARED irrmz AS STRING
 DIM SHARED ivi AS LONG
 DIM SHARED ji AS LONG
 DIM SHARED jwi AS LONG
 DIM SHARED kbz AS STRING
 DIM SHARED keyi AS LONG
 DIM SHARED keyz AS STRING
 DIM SHARED ki AS LONG
 DIM SHARED kz AS STRING
 DIM SHARED lbi AS LONG
 DIM SHARED lcti AS LONG
 DIM SHARED lenfd AS DOUBLE
 DIM SHARED li AS LONG
 DIM SHARED lki AS LONG
 DIM SHARED logfz AS STRING
 DIM SHARED logi AS LONG
 DIM SHARED lvi AS LONG
 DIM SHARED lwi AS LONG
 DIM SHARED lxi AS LONG
 DIM SHARED lz AS STRING
 DIM SHARED mrk AS STRING
 DIM SHARED mdz AS STRING
 DIM SHARED mlci AS LONG
 DIM SHARED mli AS LONG
 DIM SHARED mlz AS STRING
 DIM SHARED mrz AS STRING
 DIM SHARED myci AS LONG
 DIM SHARED mz AS STRING
 DIM SHARED nami AS LONG
 DIM SHARED namz AS STRING
 DIM SHARED ncli AS LONG
 DIM SHARED neni AS LONG
 DIM SHARED neri AS LONG
 DIM SHARED nini AS LONG
 DIM SHARED newvi AS LONG
 DIM SHARED nfi AS LONG
 DIM SHARED nhl AS LONG
 DIM SHARED nti AS LONG
 DIM SHARED noermi AS LONG
 DIM SHARED noi AS LONG
 DIM SHARED nri AS LONG
 DIM SHARED nui AS LONG
 DIM SHARED numf AS STRING
 DIM SHARED nxi AS LONG
 DIM SHARED nz AS STRING
 'DIM opcz AS STATIC STRING
 DIM SHARED opgz AS STRING
 DIM SHARED opi AS  LONG
 'DIM opki AS STATIC LONG
 'DIM opkz AS STATIC STRING
 DIM SHARED oz AS STRING
 DIM SHARED pai AS LONG
 DIM SHARED pari AS LONG
 DIM SHARED pbi AS LONG
 DIM SHARED pd AS DOUBLE
 DIM SHARED pdi AS LONG
 DIM SHARED pgz AS STRING
 DIM SHARED pi AS LONG
 DIM SHARED pid AS DOUBLE
 DIM SHARED pii AS LONG
 DIM SHARED pmni AS LONG
 DIM SHARED poi AS LONG
 DIM SHARED pqi AS LONG
 DIM SHARED prci  AS LONG
 DIM SHARED prgeni AS LONG
 ' DIM prgi AS STATIC LONG
 DIM SHARED prgpti AS LONG
 DIM SHARED prgseli AS LONG
 DIM SHARED pri AS LONG
 DIM SHARED prmi AS LONG
 DIM SHARED proz AS STRING
 DIM SHARED prynz AS STRING
 DIM SHARED pti AS LONG
 DIM SHARED pui AS LONG
 DIM SHARED pvi AS LONG
 DIM SHARED pwi AS LONG
 DIM SHARED pz AS STRING
 DIM SHARED qai AS LONG
 DIM SHARED qd AS DOUBLE
 DIM SHARED qfi AS LONG
 DIM SHARED qii AS LONG
 DIM SHARED qpz AS STRING
 DIM SHARED qui AS LONG
 DIM SHARED quz AS STRING
 DIM SHARED rd AS DOUBLE
 DIM SHARED rtdd AS DOUBLE
 DIM SHARED rz AS STRING
 DIM SHARED sbi AS LONG
 DIM SHARED selfi AS LONG
 DIM SHARED swdi AS LONG
 DIM SHARED tblp AS UBYTE POINTER
 DIM SHARED ti AS LONG
 DIM SHARED tki AS LONG
 DIM SHARED tkli AS LONG
 DIM SHARED toki AS LONG
 DIM SHARED trui AS LONG
 DIM SHARED tti AS LONG
 DIM SHARED ud AS DOUBLE
 DIM SHARED undi AS LONG
 DIM SHARED vadi AS LONG
 DIM SHARED vd AS DOUBLE
 DIM SHARED vfdi AS LONG
 DIM SHARED vai AS LONG
 DIM SHARED vei AS LONG
 DIM SHARED voi AS LONG
 DIM SHARED waz AS STRING
 DIM SHARED wd AS DOUBLE
 DIM SHARED wexi AS LONG
 DIM SHARED whi AS LONG
 DIM SHARED wpi AS LONG
 DIM SHARED wtz AS STRING
 DIM SHARED wwi AS LONG
 DIM SHARED wz AS STRING
 DIM SHARED xiti AS LONG
 DIM SHARED zzz AS STRING*128


'ENTRY POINT

 '--- Using a thread ---
 ' communicate to script by passing messages in variables 
 ' vaz, vcz, vcd and vsi 90-99 TO 100-110 FROM recommended
 '
 ' hInstance=THREADCREATE (@mains,0)
 ' THREADWAIT(hInstance)
 

 '--- Using reenter loop ---
 ' supporting occasional execution and ability to insert function calls etc
 ' self suspend once by using  'pass 2'
 ' self suspend at end of every line by using 'pass 3'
 ' suspend, start a thread and reenter in thread mode 4
 '
 DO
  ' vcd(10)=0: hInstance=THREADCREATE (@mains,0):exit do
  mains(0): IF (vcd(10)<2)OR(vcd(10)>3) THEN EXIT DO
  ' other loop code here
  ' can insert function call strings into az
 LOOP
 IF vcd(10)=4 THEN
  vcd(10)=2: vcd(12)=1:hInstance=THREADCREATE (@mains,0) ' script now running in its own thread
 end if
  ' other code here if the thread is running.
 IF hInstance<>0 THEN THREADWAIT(hInstance) 'wait till completion of thread

 
end




SUB mains (BYVAL hInstance AS LONG)

IF vcd(10)<2 THEN init() ' otherwise resume operation
IF (vcd(10)>2) THEN
  IF (az="") THEN GOTO reenter
ELSE
 vcd(10)=0
END IF
DO
 IF ii>LEN(az) THEN
  ii=1:az="":undi=0:nhl=0
  SLEEP vcd(11): IF vcd(10)>1 THEN EXIT DO ' suspend
  reenter:
  IF (prgseli=0)OR(prgpti>=prgeni)OR(vcd(10)=1) THEN
   dfinish():vcd(10)=1: EXIT DO
  end if
  az=aza(prgpti):  prgpti+=1
 END IF
 progo()
LOOP
END SUB

SUB init()
pid=ATN(1)*4: dtrd=pid / 180: rtdd=180 / pid
FOR ai=1 TO 15:vsi(ai)=1:NEXT
vaz(0)="LibBuffer":vcz(0)=STRING$(65536,CHR$(0))
vaz(1)="WordPos"
vaz(2)="WordNextPos"
vaz(3)="WordLength"
vaz(4)="WordAsc"
vaz(5)="WordNextAsc"
vaz(9)="FileLock"
vaz(10)="StopMode"
vaz(11)="Sleep"
vaz(12)="Thread"
vaz(16)="MouseX"
vaz(17)="MouseY"
vaz(18)="MouseW"
vaz(19)="MouseB"
vaz(30)="Command":vcz(30)=COMMAND$
vaz(31)="ParamBase":vsi(31)=1
vaz(32)="FunctionList": vaz(64)="FunctionSet" '+21 more each
'
pai=vcd(31):if pai<128 then pai=128
pmni=pai: neni=0
fti=PRIVBASE:fvi=fti
erci=0:ermx=64

mlz="`": mrz="`": mli=ASC(mlz):myci=1
charz="+-*/<>=?,();|"
cnarz="":quz=chr$(34)+chr$(39)+chr$(IQUOT)+"!"
' []{} also included
vcz(64)=""
vcz(32)=_
 " 01 abs 02 atnd 03 atan 04 atand 05 asc"+_
 " 06 append 07 *attrib* 08 chr 09 cos 10 cosd"+_
 " 11 color 12 date 13 deletefile 14 directory 15 cls"+_
 " 16 dir 17 eof 18 environ 19 error 20 file"+_
 " 21 fix  22 frac 23 get 24 hex 25 in"+_
 " 26 input 27 int 28 lower 29 len 30 lof"+_
 " 31 log 32 lock 33 getkey 34 mod 35 midl"+_
 " 36 mid 37 min 38 max 39 minmax 40 ***"+_
 " 41 num 42 numbers 43 close 44 out 45 output"+_
 " 46 *** 47 read 48 params 49 pos 50 quest"+_
 " 51 put 52 power 53 pyth 54 prepos 55 range"+_
 " 56 many 57 replace 58 randomize 59 random 60 round"+_
 " 61 resources 62 str 63 seek 64 exp 65 sgn"+_
 " 66 *** 67 *** 68 sin 69 sind 70 *sort*"+_
 " 71 tan 72 tand 73 trim 74 time 75 timer"+_
 " 76 type 77 upper 78 unlock 79 getmouse 80 val"+_
 " 81 locate 82 version 83 word 84 chdir 85 mkdir"+_
 " 86 rmdir 87 shell "


'max 255 internal functions
'max 41 commands + ops (excluding +-*/=)

cmz=_
 " 01 ref 02 *** 03 def 04 do 05 end"+_
 " 06 errors 07 endif 08 exit 09 function 10 if"+_
 " 11 patch 12 namespace 13 new 14 quit 15 repeat"+_
 " 16 return 17 set 18 cut 19 GE 20 GT"+_
 " 21 LE 22 LT 23 EQ 24 NE 25 not"+_
 " 26 and 27 or 28 xor 29 exec 30 ***"+_
 " 31 to 32 *** 33 goto 34 load 35 unload"+_
 " 36 *** 37 *** 38 *** 39 ***"+_
 " 40 *endf* 41 *iquotes* "


 noermi=1:prynz="nul"
 crz=cat2(CHR$(13),CHR$(10))
 '
 prgseli=0:logfz="log.txt"
 mdz="o":ffz=logfz: oopen():logi=fci
 procz(prci,0)="main": procz(prci,1)="()"
 proci(prci,0)=0:prci+=1 'default main
 az="load 'main';main()": tokenise():aza(0)=az: prgpti=1
 prgeni=1:ii=1
END SUB



SUB progo()
words(): bbi=lxi
IF bbi=0 THEN az="": EXIT SUB

SELECT CASE AS CONST bbi-CMDBASE

CASE 01'refs
 EXIT SUB
CASE 02'
 EXIT SUB
CASE 06 'errors
 ermx=-1:words():IF lwi THEN ermx=VAL(wz):EXIT SUB
CASE 07'endif
 EXIT SUB
CASE 03'def
 dreturn():EXIT SUB
CASE 05'end
 dreturn():EXIT SUB
CASE 09'function
 dreturn():EXIT SUB
CASE 04:'do
 words():ddo():EXIT SUB
CASE 08:'exit
 ci=cpi(prgpti-1): IF ci THEN ci=cpi(ci)
 IF ci THEN prgpti=ci
 EXIT SUB
CASE 10'if
 condi=1:expr():EXIT SUB
CASE 11' buffer
 words():ioi=4:vario()
 if vfdi>0 then
  qii=vfdi:ii+=1:expr(): mid$(vcz(qii),vcd(pai))=bcz
 end if
 EXIT SUB
CASE 12'namespace
 words(): namz=wz:nami=lwi
 EXIT SUB
CASE 13'new
 newvi=1: expr()
 EXIT SUB
CASE 14:'quit
 dfinish():EXIT SUB
CASE 15'repeat
 ci=cpi(prgpti-1): IF ci THEN prgpti=ci+1
 EXIT SUB
CASE 16'return
 expr():dreturn():EXIT SUB
CASE 17:'set
 undi=1:EXIT SUB
CASE 18:'cut
 words():ioi=3:vario():ioi=0:EXIT SUB
CASE 29 ' exec
 nhl=1:expr():gz=";"+MID$(az,ii)
 az=bcz:ii=1:pdi=pmni:tokeval():ii=1:az=az+gz
 IF ctbi<>0 THEN az="":ctbi=0 'todo error
 EXIT SUB
CASE 30  'undefined
 EXIT SUB
CASE 31 'to
 words():dez=wz:tto():EXIT SUB ' assign
CASE 33 'goto
 words()
 IF LEN(wz) THEN
  wz=cat2(CHR$(58),wz):az=""
  DO
   ai=asc(aza(prgpti))
   IF ai=123 THEN blv(bli)=pai:bli+=1 ' {
   IF ai=125 THEN bli-=1:pai=blv(bli) ' }
   IF (ai=133)OR(prgpti>=prgeni) THEN
    arz="Label not found":errms():EXIT DO
   end if
   IF aza(prgpti)=wz THEN prgpti+=1:EXIT DO
   prgpti+=1
  LOOP
 END IF
 EXIT SUB
CASE 34:'load
 nhl=1:expr():pgz=bcz:denter():loadprog():dreturn(): EXIT SUB
CASE 35'unload
 IF ncli<1 THEN arz="No files to unload": errms():EXIT SUB
 ncli-=1: pi=incli(ncli,0):prgeni=pi:prci=incli(ncli,1):EXIT SUB
CASE 40:'end
 dreturn():EXIT SUB 'endf end function
CASE 41: 'iquote
 GOTO asx
END SELECT

SELECT CASE AS CONST bbi
CASE 123 '{
 IF bli<63 THEN blv(bli)=pai:bli+=1
 EXIT SUB
CASE 125 '}
 IF bli>0 THEN bli-=1:pai=blv(bli)
 EXIT SUB
CASE 61 ' =
 words():dez=wz:tto():EXIT SUB ' = assign
CASE 63 ' ? 
 logprint(): EXIT SUB
CASE 34 ' "
 GOTO asx
CASE DLI
 EXIT SUB

END SELECT

azl:
 
 IF bbi=58 THEN mrk=az: az="": EXIT SUB ' mark location
 IF (bbi>39)AND(bbi<48) THEN ii=pii:expri():EXIT SUB ' accumulation etc
 IF (bbi>=FUNBASE)AND(bbi<=USEFUN) THEN GOTO asx
 IF (nxi=43)AND(ASC(az,ii+1)=43) THEN GOTO asx ' preincrement
 IF (nxi=45)AND(ASC(az,ii+1)=45) THEN GOTO asx ' predecrement
 IF (nxi=42)OR(nxi=43)OR(nxi=45)OR(nxi=47) THEN
  IF ASC(az,ii+1)=61 THEN dez=wz:ii=pii: expr():tto():EXIT SUB '+= -= *= /=
 END IF
 IF (nxi=61)OR(nxi=44)OR(nxi=91) THEN
  ai=INSTR(ii,az,"=")
  IF ai THEN
   ii=pii:dez="" 'parse avoiding nested = etc
   qii=pii:lvi=0
   do
    words()
    if (lxi=40)or(lxi=91) then lvi+=1
    if (lxi=41)or(lxi=93) then lvi-=1
    if (lxi=61)and(lvi=0) then exit do
    if (lxi=0)or(lxi=dli) then dez="":ii=qii:exit do
    dez=dez+wz
   loop
   expr():tto():EXIT SUB
  END IF
 END IF

asx:
ii=pii:expr() 'default
END SUB



SUB logprint()
 ERR=0
 IF nui=1 THEN
  PRINT #logi, STR$(accd):  PRINT STR$(accd)
  efi=ERR: EXIT SUB
 end if
 PRINT #logi,bcz: PRINT bcz: erfi=ERR
END SUB



SUB openin()
 mdz="i": vd=0:ERR=0
 IF LEN(bz) THEN
  inlz=bz:ffz=inlz:oopen()
  IF EOF(fci) THEN vd=1:cloose():EXIT SUB
  vd=erfi
  IF erfi THEN
   arz=cat2("Missing file: ",inlz):errms():inlz="":EXIT SUB
  end if
 END IF
END SUB



SUB opens()
 prynz="nul": IF LEN(bz)>0 THEN prynz=bz
 ffz=prynz:oopen()
 IF erfi>0 THEN arz=prynz+":":errms():prynz="nul"
END SUB



SUB ddo()
 IF wz="" THEN arz="Function name expected": errms():EXIT SUB
 ai=VAL(wz):pz=""
 IF ai THEN
  fbi=prgpti+ai 'relative +1-1
 ELSE
  searchbegin()
  IF bi>=0 THEN pz=procz(bi,1):fbi=proci(bi,0)+1
  IF fbi=0 THEN
   wz="":accd=0
   IF neri=0 THEN arz=cat2("Cant find function: ",wz):errms()
   EXIT SUB
  END IF
 END IF
 denter()
END SUB



SUB searchbegin()
 fbi=0:bi=-1
 IF ASC(wz)=USEFUN THEN bi=CVSHORT(MID$(wz,2)): EXIT SUB
 bi=prci-1
 WHILE bi>=0
  IF procz(bi,0)=wz THEN
   IF ASC(procz(bi,1))=40 THEN EXIT SUB
   wz=procz(bi,1):bi=prci ' reroute function option
  END IF
  bi-=1
 WEND
 ' nhl prevents hard linking
 IF (nhl<>0)OR(bi<0)OR(bi>=FUNUMAX) THEN EXIT SUB
 'patch quickref
 cz=wz: ji=ii:ii=1
 WHILE ii<ji:words()
  IF wz=cz THEN
   inserts(aza(prgpti-1),cat2(CHR$(USEFUN),_
   MKSHORT$(bi)),swdi,swdi+LEN(wz)):ji=ji+3-LEN(wz)
   EXIT WHILE
  END IF
 WEND
 ii=ji
END SUB



SUB denter()
 IF prgseli>=63 THEN
  arz="Too many routines in stack":errms():EXIT SUB
 end if
 prgi(prgseli,0)=prgpti: prgpti=fbi
 prgi(prgseli,1)=undi
 prgi(prgseli,2)=neni
 prgi(prgseli,4)=pmni
 prgi(prgseli,5)=fvi
 prgi(prgseli,6)=fti
 prgi(prgseli,7)=condi:condi=0
 prgi(prgseli,8)=efi:efi=0
 prgz(prgseli,0)=proz:proz=wz
 prgz(prgseli,1)=namz:namz=""
 prgz(prgseli,2)=dez:dez=""
 prgz(prgseli,3)=MID$(az,ii)
 nami=0:az="":ii=1:prgseli+=1
END SUB



SUB dreturn()
 IF prgseli<=0 THEN prgseli=0:EXIT SUB
 prgseli-=1
 prgpti=prgi(prgseli,0)
 undi=prgi(prgseli,1)
 neni=prgi(prgseli,2)
 pmni=prgi(prgseli,4)
 fvi=prgi(prgseli,5)
 fti=prgi(prgseli,6)
 condi=prgi(prgseli,7)
 efi=prgi(prgseli,8)
 proz=prgz(prgseli,0)
 namz=prgz(prgseli,1)
 dez=prgz(prgseli,2)
 az=prgz(prgseli,3)
 nami=LEN(namz)
 ii=1:IF efi THEN expr():tto()
END SUB



SUB dfinish()
 CLOSE:prgseli=0:prgpti=0:prgeni=0:pai=20
 fhi=0:whi=0:az="":prci=0:ncli=0: accd=0
 FOR ai=1 TO tkli:DYLIBFREE tpi(ai):NEXT
 tkli=0
 'purge strings?
END SUB





SUB loadprog()
 mlci=myci:myci=1:cli=prgeni
 fpi=fhi:wpi=whi
 lcti=0:ctbi=0:bcli=cli
 nfi=0:mdz="i":opgz=pgz
 pdi=pai
 nextinclude:
 'prgi=0
 ffz=cat2(pgz,".pro"):oopen()
 IF erfi THEN
  arz=cat2("Missing file: ",pgz):errms():dfinish():EXIT SUB
 end if
 fi(nfi)=fci
 IF nfi=0 THEN
  incli(ncli,0)=prgeni:incli(ncli,1)=prci:inclz(ncli)=pgz
  IF ncli<100 THEN ncli+=1
 end if
 DO
  IF EOF(fi(nfi)) THEN
   CLOSE(fi(nfi)): nfi-=1:IF nfi<0 THEN EXIT DO
  end if
  ERR=0: LINE INPUT #fi(nfi),az
  IF ERR THEN
   arz=cat2("error reading ",pgz):errms():dfinish():EXIT SUB
  end if

  az=LTRIM$(az)
  ai=instr(az,"|")
  if ai>0 then az=left$(az,ai-1) ' you cannot  use '|' in literals
  az=cat2(abz,RTRIM$(az)):abz="": lcti+=1
  IF RIGHT$(az,1)="_" THEN
   abz=LEFT$(az,LEN(az)-1)+crz: CONTINUE DO
  end if
  IF az="" THEN CONTINUE DO
  lxi=asc(az): IF (lxi=39)OR(lxi=47) THEN CONTINUE DO
  acz=az
  ii=1:words()
  IF wz="include" THEN
   expr():pgz=bcz:nfi+=1
   IF nfi>16 THEN arz="includes":toomany():EXIT SUB
   GOTO nextinclude
  END IF
  tokenise()
  IF prci>=FUNUMAX THEN arz="routines in memory":toomany():EXIT SUB
  IF ctbi>0 THEN arz=cat2("left brackets",acz):toomany():EXIT SUB
  IF ctbi<0 THEN arz=cat2("right brackets",acz):toomany():EXIT SUB
  '
  IF LEN (az) THEN aza(cli)=az: cli+=1
  IF cli>=CODEMAX THEN
   arz=cat2("lines loading:  ",pgz):toomany():EXIT SUB
  END IF
 LOOP
 loadprgx:
 IF fhi<>fpi THEN arz="'ifs' loading":toomany():EXIT SUB
 IF whi<>wpi THEN arz="'blocks' loading ":toomany():EXIT SUB
 myci=mlci
 prgeni=cli
END SUB



SUB toomany()
 arz=cat2(cat4("Too many ",arz,_
 " loading ",pgz),cat2(" line ",STR$(lcti)))
 errms(): dfinish()
END SUB



SUB tokenise()
 retok:
 toki=1:neri=1:cpi(cli)=0: cti=-1:newvi=0
 ii=1:words()
 IF (lxi<CMDBASE)AND(nxi<>40) THEN
  IF wz="begin" THEN az=MID$(az,ii):words()
  IF wz="private" THEN
   newvi=1:SWAP fti,pai:expr():az="":SWAP pai,fti
  end if
  IF wz="keys" THEN newvi=1:keyi=1:expr():az="":keyi=0
  IF wz="new" THEN az=cat2(CHR$(141),MID$(az,ii))
  IF wz="function" THEN az=cat2(CHR$(137),MID$(az,ii))
  IF wz="meta" THEN az=""
  IF wz="iquotes" THEN
   myci=0:words()
   IF lwi THEN
    mlz=MID$(wz,1,1):mli=lxi:words():
    IF lwi THEN mrz=MID$(wz,1,1):myci=1
   end if
   az=""
  END IF
  IF wz="end" THEN
   words():az=CHR$(133) 'default end def etc
   IF wz="if" THEN az=CHR$(135)
   IF wz="function" THEN az=CHR$(168)
  END IF
  ii=1:words()
 END IF
 IF wz="endif" THEN az=CHR$(135)
 IF wz="library" THEN
  expr() '.dll or .so
  hLib = DYLIBLOAD(bz)
  IF hLib=0 THEN
   arz=cat2("cant find library ",wz):errms()
   dfinish():EXIT SUB
  end if
  libvars = DYLIBSYMBOL(hLib, "vars")
  IF libvars=0 THEN
   arz=cat2("cant find library functions ",bz)
   errms():dfinish():EXIT SUB
  end if
  libvars( PARAMAX,vsi(),vcd(),vcz() )
  libfuns = DYLIBSYMBOL(hLib, "funs")
  IF libfuns=0 THEN
   arz=cat2("cant find library functions ",bz)
   errms():dfinish():EXIT SUB
  end if
  tkli+=1
  IF tkli>NLIBS THEN
   arz="too many libraries":errms():dfinish():EXIT SUB
  end if
  vcz(pai)=STRING$(LIBRBUFF,CHR$(0))
  funi=0: libfunction()
  vcz(tkli+32)=bz:tpi(tkli)=hLib:tfi(tkli)=libfuns
  vcz(tkli+64)=namz
  funi=1:libfunction(): az="new "+bz
  goto retok
 END IF
 lxi=ASC(az)
 SELECT CASE AS CONST lxi
 CASE 135
  fhi-=1: IF fhi>=0 THEN cpi(fhii(fhi))=cli
  GOTO tokenisex '07 endif
 CASE 123
  IF whi<63 THEN whii(whi)=cli: whi+=1:blv(bli)=pai:bli+=1
  GOTO tokenisex '02 block
 CASE 125
  whi-=1
  IF whi>=0 THEN
   cpi(cli)=whii(whi-1):cpi(whii(whi))=cli
   bli-=1:pai=blv(bli)
  end if
  GOTO tokenisex '06 endb
 CASE 141
  newvi=1:expr():newvi=1'new
 CASE 168
  keyz=" ":lki=0:pai=pdi:infi=0
  proci(prci-1,2)=fti:namz="":nami=0 'endf end function
 CASE 137
  keyz=" ":lki=0:pai=pdi:infi=0
  proci(prci-1,2)=fti:namz="":nami=0 'function
  pdi=pai:infi=1:fvi=fti:proci(prci,1)=fti 'function
  words()
  IF prci<FUNUMAX THEN 
   procz(prci,0)=wz: az=MID$(az,ii):ii=1
   newvi=10:tokeval():newvi=0
   procz(prci,1)=az: proci(prci,0)=cli
   prci+=1: az=chr$(137)
  END IF
  GOTO tokenisex
 END SELECT
 ii=1:tokeval()
 'linking
 ii=1:dlmi=0:dlxi=0
 DO
  words()
  IF lwi=0 THEN EXIT DO
  SELECT CASE AS CONST lxi
  CASE 131 ' AND(prgi=0) THEN ' 03 def
   hbz=az:hbi=ii
   words():kbz=wz:ji=0
   WHILE ji<lki
    IF lnkz(ji)=kbz THEN
     az=aza(lnki(ji,0)):ki=lnki(ji,1)
     MID$(aza(lnki(ji,0)),ki)=STR$(cli-lnki(ji,0))
     lnkz(ji)="":ii=ki:words() 'relative links max 9999
    END IF
    ji+=1
   WEND
   az=hbz:ii=hbi:wz=""
  CASE 132  'AND(prgi=0) THEN ' 04 do 'fwd linking list
   lnki(lki,0)=cli:lnki(lki,1)=ii:words()
   lnkz(lki)=wz:inserts(az,"?   ",pii,ii)
   ii=pii:words():lki=IIF(lki>254,255,lki+1)
  CASE 138 ' 10 if
   IF dlmi=0 THEN dlmi=-1
  CASE 140 ' 12 namespace
   words():namz=wz:nami=LEN(namz)
  CASE 143 ' 15 repeat
   dlxi=-2: IF whi>0 THEN cpi(cli)=whii(whi-1)
  CASE 136 ' 08 exit
   dlxi=-1: IF whi>0 THEN cpi(cli)=whii(whi-1)
  CASE DLI ';
   IF (dlmi=-1)AND(nxi>0) THEN dlmi=1
  END SELECT
 LOOP
 IF dlmi=-1 THEN
  IF fhi<63 THEN fhii(fhi)=cli: fhi+=1 'ifi=135 '10 if block
 end if
 tokenisex:
 ii=1:neri=0:toki=0:newvi=0
END SUB



SUB tokeval()
 ti=ii
 DO
  words()
  nini=0
  IF nxi=61 THEN IF ctbi>0 THEN nini=1
  IF INSTR(" then also but ",cat3(" ",wz," ")) THEN
   az=cat3(LEFT$(az,swdi-1),";",MID$(az,ii)):ii=swdi+1
   CONTINUE DO
  end if
  ' string macs
  IF INSTR(quz,CHR$(lxi))>0 THEN
   IF INSTR(wz,mlz) THEN
    wz=MID$(wz,2,LEN(wz)-2):wordmac()
   inserts(az,cz,swdi,ii):ii=swdi:words()
   end if
  END IF
  ai=0
  SELECT CASE AS CONST lxi
  CASE 0
   EXIT DO
  CASE 36
   wz=MID$(az,swdi+1):wordmac()
   inserts(az,cat3("out(0,",cz,"chr 13+chr 10)"),swdi,32767)
   ii=swdi
   'print az
   CONTINUE DO
  CASE 47
   IF nxi=47 THEN
    bz=az:az=RTRIM$(MID$(az,1,swdi-1)):EXIT DO
   end if
  CASE 40
   ctbi+=1
  CASE 41
    ctbi-=1
  END SELECT

  IF lxi>62 THEN
   'check commands
   ai=INSTR(cmz,cat3(" ",wz," "))
   IF ai THEN
    inserts(az,CHR$(CMDBASE+VAL(MID$(cmz,ai-2,2))),swdi,ii)
    ii=swdi+1:GOTO xtokeval
   end if
   ' tokenise built-in functions
   bi=0
   WHILE bi<=tkli
    cz=wz:ai=1
    IF bi>0 THEN
     bz=vcz(bi+64):ai=LEN(bz)
     IF ai>0 then
      ai=INSTR(cz,bz):IF ai=1 THEN cz=MID$(cz,len(bz)+1)'strip off
     end if
     IF namz=bz then ai=1
    END IF 
    IF ai>0 then ai=INSTR(vcz(bi+32),cat3(" ",cz," "))
    IF ai>0 THEN
     ez=CHR$(VAL(LTRIM$(MID$(vcz(bi+32),ai-3,4)))) '0..255
     IF (nxi=40)AND(MID$(az,ii+1,1)=")") THEN
      ii=ii+2:ez=cat2(ez,CHR$(DUMMY)) 'no args ()
     end if
     inserts(az,cat2(CHR$(IFUNS-bi),ez),swdi,ii)
     ii=swdi+LEN(ez)+1:GOTO xtokeval
     EXIT WHILE
    END IF
    bi+=1
   WEND
  END IF
  IF (nxi<>40)AND(nxi<>mli)AND(newvi=0) THEN
   ' insert consts static and local indexed
   csti=0
   IF lxi=35 THEN wz=MID$(wz,2):lxi=ASC(wz):csti=1
   IF ((lxi>64)AND(lxi<91))OR((lxi>96)AND(lxi<123)) THEN
    IF pti THEN nxi=pti:ii=pti:wz=LEFT$(wz,pti-bwi)
    vario()
    IF vfdi>0 THEN
     IF (csti=1)OR(INSTR(keyz,cat3(" ",wz," "))) THEN
      IF nui=1 THEN bz=STR$(vd)
      inserts(az,cat2(bz," "),swdi,ii):ii=swdi+LEN(bz)+1 'const
     ELSEIF (vfdi>=pdi)AND(nini=0) THEN
      IF vfdi-pdi<VARMAX THEN
       inserts(az,CHR$(VARBASE+vfdi-pdi),swdi,ii):ii=swdi+1 'local var
      ELSEIF vfdi>=fvi THEN
       inserts(az,cat2(CHR$(PRIVAR),CHR$(vfdi-fvi)),swdi,ii)
       ii=swdi+2 'static var
      ELSE
       'concat null bug workaround
       inserts(az,cat2(CHR$(LONGVAR),_
        MKSHORT$(vfdi-pdi)),swdi,ii)
       ii=swdi+3 'long ref var
      END IF
     END IF
     IF pti THEN ii=ii+lwi+bwi-pti
    END IF
   END IF
  END IF
  xtokeval:
 LOOP
 nini=0
END SUB



SUB prynt()
IF pri=0 THEN PRINT bz; : PRINT #logi,bz; : EXIT SUB
ERR=0 
vd=0: PRINT #pri,bz; :vd=ERR
IF vd THEN arz="output problem":eri=ERR:errms(): vd=erfi
bz=""
END SUB



SUB words()
IF ii<1 THEN ii=1
pii=ii
ip=STRPTR(az)-1:lbi=LEN(az)
lxi=0
WHILE ii<=lbi
 lxi=ip[ii]
 IF lxi>32 THEN EXIT WHILE
 ii+=1
WEND
bwi=ii:swdi=ii:chi=0:pti=0
'scan
WHILE ii<=lbi
 cwi=ip[ii]
 'IF (cwi=34)OR(cwi=39)OR(cwi=IQUOT) THEN
 qui=instr(quz,chr$(cwi))
 if qui>0 then
  IF ii=bwi THEN
   ii=INSTR(ii+1,az,CHR$(cwi)):IF ii=0 THEN ii=lbi
   ii+=1
  END IF
  EXIT WHILE
 ELSEIF cwi=46 THEN
  IF pti=0 THEN pti=ii
 ELSEIF cwi>=LONGBASE THEN
  IF ii=bwi THEN ii=ii+3
  IF (ii>lbi)OR(ip[ii]<>46) THEN EXIT WHILE 'longvar
 ELSEIF cwi>=FUNBASE THEN
  IF ii=bwi THEN ii=ii+2
  IF (ii>lbi)OR(ip[ii]<>46) THEN EXIT WHILE 'function ' function or private var
 ELSEIF cwi>=VARBASE THEN
  IF ii=bwi THEN ii=ii+1
  IF (ii>lbi)OR(ip[ii]<>46) THEN EXIT WHILE 'local var
 ELSEIF cwi>=CMDBASE THEN
  IF ii=bwi THEN ii=ii+1
  EXIT WHILE 'cmd token
 ELSEIF cwi<=32 THEN
  EXIT WHILE
 ELSEIF (pari)AND(INSTR(cnarz,CHR$(cwi))>0) THEN
  IF ii=bwi THEN ii+=1
  EXIT WHILE
 ELSEIF (cwi=91)OR(cwi=93)OR(cwi=123)OR(cwi=125) THEN
   IF ii=bwi THEN chi=wwi:ii+=1
   EXIT WHILE
 ELSEIF cwi<65 THEN
  wwi=INSTR(charz,CHR$(cwi))
  IF wwi THEN
   IF ii=bwi THEN chi=wwi:ii+=1
   EXIT WHILE
  END IF
 END IF
 ii+=1
WEND
jwi=ii:nxi=0
'skip spaces after word
WHILE ii<=lbi
 cwi=ip[ii]:IF cwi>32 THEN nxi=cwi:EXIT WHILE
 ii+=1
WEND
lwi=jwi-bwi
wz=MID$(az,bwi,lwi)
END SUB



SUB wordmac()
nz=CHR$(IQUOT):IF myci=0 THEN cz=nz+wz+nz+"+":EXIT SUB
li=LEN(wz):cz="": IF li=0 THEN EXIT SUB
awi=1
DO
 ai=awi:awi=INSTR(awi,wz,mlz): IF awi=0 THEN awi=li+1
 cz= cz + nz + MID$(wz,ai,awi-ai) + nz + "+"
 IF awi>li THEN EXIT DO
 bwi=INSTR(awi+1,wz,mrz):IF bwi=0 THEN bwi=li+1
 cz += "num(" + LTRIM$(RTRIM$(MID$( wz,awi+1,bwi-awi-1 ))) _
  + ")+" : awi=bwi+1
LOOP
END SUB



SUB vario()
namesplit():IF wz="" THEN EXIT SUB
wexi=128
vfdi=0:ivi=ASC(wz)
IF ivi= 64 THEN vfdi=VAL(MID$(wz,2)):refs():EXIT SUB
IF ivi= PRIVAR THEN vfdi=ASC(wz,2)+fvi: refs():EXIT SUB
IF ivi=LONGVAR THEN vfdi=CVSHORT(MID$(wz,2,2))+pmni: refs():EXIT SUB
IF ivi>=VARBASE THEN vfdi=ivi-VARBASE+pmni:refs():EXIT SUB
IF nami THEN IF INSTR(wz,":")=0 THEN kz=cat2(namz,wz):varsearch()
IF vfdi=0 THEN kz=wz:varsearch()
refs()
END SUB



SUB varsearch()
bvi=fti-1:bsi=fvi:srch():IF vfdi=0 THEN bvi=pai-1:bsi=1:srch()
END SUB



SUB srch()
WHILE bvi>=bsi
 IF kz=vaz(bvi) THEN vfdi=bvi:wz=kz:EXIT WHILE
 bvi-=1
WEND
END SUB



SUB loopref()
IF vfdi THEN
 DO
  nri=vsi(vfdi): IF nri>=0 THEN EXIT DO
  vfdi=-nri: wexi-=1
  IF wexi<0 THEN
   arz=cat2("Cannot resolve ref: ",wz):errms()
   notfound():EXIT DO
  end if
 LOOP
END IF
END SUB



SUB refs()
loopref()
vfdi=vfdi+ari

IF vfdi>0 THEN
 if ioi=4 then goto xitp
 IF pti THEN
  dz=vcz(vfdi)
  dj=1:ai=0:bi=0:ahi=0
  lz="<":rz=">"
  DO
   'exit sub
   ez=cat3(lz,eza(dj),rz)
   li=0:gi=LEN(ez)
   DO 'find start tag
    ai=INSTR(ai+1,dz,lz)
    IF ai=0 THEN bz="":vd=0:goto xito ' no error given
    li+=1:cz=MID$(dz,ai+1,1)
    IF cz="/" THEN
     li=li-2: IF li<0 THEN ai=0:EXIT DO
    ELSEIF cz=lz THEN 'esc
     ai+=1:li-=1
    ELSEIF li=1 THEN
     IF MID$(dz,ai,gi)=ez THEN
      ai=ai+gi-1:ahi=ai: EXIT DO
     END IF
    END IF
   LOOP
   IF dj>=ei THEN EXIT DO
   dj+=1 'next nest in
  LOOP

  li=1:bi=ai:ai+=1
  DO 'find end tag
   bi=INSTR(bi+1,dz,lz):li+=1:IF bi=0 THEN goto xito ' no err given
   if bi then IF MID$(dz,bi+1,1)=lz THEN bi+=1: CONTINUE DO ' << escape mark
   IF MID$(dz,bi+1,1)="/" THEN
    li=li-2: IF li<0 THEN ai=0:EXIT DO
    IF li=0 THEN EXIT DO 'success
   END IF
  LOOP
  IF ioi=0 THEN
   nui=0: ci=ASC(dz,ai):li=bi-ai-1:bz=""
   IF li>=0 THEN bz=MID$(dz,ai+1,li)
   IF ci=35 THEN vd=VAL(bz):nui=1: goto xito
   IF ci<>32 then bz=chr$(ci)+bz ' tolerate misformed markup
   goto xito
  elseif ioi=1 THEN
   ci=32:IF nui=1 THEN ci=35:bcz=STR$(accd)
   inserts(vcz(vfdi),CHR$(ci)+bcz,ai,bi):goto xito
  elseif ioi=2 THEN
   nui=1:vd=bi-ai:goto xito
  elseif ioi=3 THEN
   inserts(vcz(vfdi),"",ai-gi,INSTR(bi,dz,rz)+1) 'cut
  end if
  xito:
  ioi=0
  EXIT SUB
 END IF

 primitives:

 IF ioi=0 THEN
  nui=vsi(vfdi) AND 1: IF nui=1 THEN vd=vcd(vfdi): goto xitp
  bz=vcz(vfdi)
 ELSEIF ioi=1 THEN
  IF (vfdi<pmni)AND(undi=0) THEN
   arz=cat2("Warning changing variable used elsewhere ",wz):errms()
  end if
  vsi(vfdi)=nui: IF nui=1 THEN vcd(vfdi)=accd:goto xitp
  vcz(vfdi)=bcz:ioi=0
 ELSEIF ioi=2 THEN
  nui=1:vd=LEN(vcz(vfdi))
 END IF

ELSE ' not found

 IF ioi=1 THEN
  IF newvi=0 THEN arz=cat3("Error: undefined var ",namz,wz):errms()
  newv()
 ELSEIF ioi=2 THEN
  nui=1: errv()
 END IF
end if
xitp:
ioi=0
END SUB



SUB newv()
vfdi=pai:vaz(vfdi)=cat2(namz,wz)
vsi(vfdi)=nui:ipa()
IF nui=1 THEN vcd(vfdi)=accd 
IF nui<>1 THEN vcz(vfdi)=bcz
END SUB



SUB namesplit()
ei=0:ai=0:pti=0
DO
 bi=INSTR(ai+1,wz,"."): if bi=0 then exit do
 eza(ei)=MID$(wz,ai+1,bi-ai-1):pti=bi
 if pti=len(wz) then wz=eza(0):exit sub
 ei+=1:ai=bi
LOOP
IF pti THEN eza(ei)=MID$(wz,ai+1):wz=eza(0)
END SUB



SUB errv()
IF neri=0 THEN arz=cat2("Cant find .var: ",wz):errms()
notfound()
END SUB



SUB notfound()
vfdi=0:bz="":vd=0:ioi=0
END SUB



SUB tto()
 IF dez="" THEN EXIT SUB
 daz=az:dai=ii
 az=dez:ii=1:ici=pvi:pai=poi
 DO ' multiassign
  if vadi=0 then
   words(): if lwi=0 then exit do
   if nxi=91 then
    do
     if pti=0 then waz=wz else waz="."+wz 
     ioi=4:vario(): vadi=vfdi
     if vadi>0 then
      pwi=pvi:pui=pai:pai=poi+1
      sbi=1:expr():sbi=0
      wz=waz: resolvar()
      vadi+=ari:ari=0:pvi=pwi:pai=pui
      if (nxi=91)and(pti<>0) then continue do
     end if
     exit do
    loop
   end if
  end if
  ioi=1:nui=vsi(ici):accd=vcd(ici):bcz=vcz(ici)
  IF vadi THEN
   vfdi=vadi:refs(): vadi+=1:ici+=1:IF ici>pai THEN EXIT DO
   IF nxi=44 THEN words():vadi=0 ' another assign ...
  ELSE
   vario(): ici=IIF(ici>=pai,pai,ici+1)
   IF nxi<>44 THEN EXIT DO 
   words() 'comma more ...
  END IF
 LOOP
 vadi=0:dez="":az=daz:ii=dai:pai=pvi
END SUB



SUB resolvar()
 if asc(wz)<>46 then
  ari=vd
 else
  vadi=0
  IF noi=1 THEN bz=STR$(vd)
  wz=cat2(MID$(wz,2),bz)
  if ii<=len(az) then
   if asc(az,ii-1)>32 then
    if (nxi=46)or((nxi>63)and(nxi<91))or((nxi>96)and(nxi<123))_
    or((nxi>47)and(nxi<58))or(nxi=95) then
     bz=wz:words():wz=cat2(bz,wz)
    end if
   end if
  end if
  pti=1
 end if
END SUB



SUB expr()
IF efi THEN
 efi=0:unnest(): nui=noi: ops()
ELSE
 clearop(): IF newvi THEN nui=2: newvar()
END IF
expri()
END SUB



SUB expri()
pvi=pai
nx1:
DO
 words()
 IF lxi=DLI THEN 'then
  IF (condi>0)AND(nxi>0) THEN
   condits():IF trui=0 THEN az=""
   condi=0:EXIT DO
  END IF
  lwi=0
 END IF
 IF (lxi=47)AND(nxi=47) THEN lwi=0: az=LEFT$(az,ii-2)
 IF lwi=0 THEN
  IF condi=0 THEN storeval()
  EXIT DO
 END IF
 analys():IF xiti>0 THEN xiti=0:EXIT SUB
LOOP
IF newvi THEN
 ipa()
 IF newvi=10 THEN
  pai=IIF(pai<nei(neni,3),nei(neni-1,3)+qai+1,pai):pbi=pai ' variable number of params
  IF selfi THEN vaz(pai)="this":vsi(pai)=selfi:vcz(pai)="":ipa()
  IF LEN(oz) THEN
   undi=1:az=MID$(oz,2):oz="":ii=1:newvi=3:ii=1:nui=2:clearop():newvar():GOTO nx1
  ELSE
   pmni=pai 'nei(neni-1,3)+1
  END IF
 ELSEIF newvi=3 THEN
  pmni=pai
 END IF
 newvi=0:selfi=0
ELSE
 poi=pai
 if pvi<pai then pai=pvi
END IF
IF condi THEN
 condits()
 IF trui=0 THEN ci=cpi(prgpti-1): IF ci>=0 THEN prgpti=ci+1' skip past endif
END IF
END SUB



SUB condits()
 condi=0: trui=1
 IF nui=1 THEN trui=accd
 IF nui=0 THEN trui=LEN(bcz)
END SUB



SUB analys()

 SELECT CASE AS CONST lxi-128
 CASE 1
  words():vario():nui=-vfdi:EXIT SUB 'refs
 CASE 19 'GE
  pqi=opi:opi=10:EXIT SUB
 CASE 20 'GT
  pqi=opi:opi=6:EXIT SUB
 CASE 21 'LE
  pqi=opi:opi=9:EXIT SUB
 CASE 22 'LT
  pqi=opi:opi=5:EXIT SUB
 CASE 23 'EQ
  pqi=opi:opi=7:EXIT SUB
 CASE 24 'NE
  pqi=opi:opi=8:EXIT SUB
 CASE 25 'not
  pqi=opi:opi=21:EXIT SUB
 CASE 26 'and
  pqi=opi:opi=31:EXIT SUB
 CASE 27 'or
  pqi=opi:opi=32:EXIT SUB
 CASE 28 'xor
  pqi=opi:opi=33:EXIT SUB
 CASE 29 'undefined
  EXIT SUB
 CASE 30 'undefined here
  EXIT SUB
 CASE 31 'TO
  words(): if nxi<>91 then ioi=1:vario():EXIT SUB
  qpz=wz:toto(neni)=1:EXIT SUB
 CASE 32 'unused
  EXIT SUB

 END SELECT

 IF lxi=63 THEN logprint():EXIT SUB

 IF lxi=IFUNS THEN
  IF nxi<>40 THEN
   tki=ASC(wz,2):evarion():noi=nui:poi=pai:intfun():EXIT SUB
  end if
 ELSEIF (lxi>FUNBASE)AND(lxi<IFUNS)AND(nxi<>40) THEN
  libfuns=tfi(IFUNS-lxi)
  funi=ASC(wz,2)
  evarion(): qai=0
  IF nxi<>DUMMY THEN storeval():qai=1
  libfunction():EXIT SUB
 END IF

 IF lxi=91 THEN
  donest():EXIT SUB
 ELSEIF lxi=93 THEN
  unnest(): IF wz="" THEN xiti=1:EXIT SUB
  resolvar()
  if nxi=91 then
   qpz=wz: IF pti THEN qpz=cat2(".",wz)
   exit sub
  end if
  if toto(neni)=0 then vario():ari=0:ops():EXIT SUB
  ioi=1:toto(neni)=0:vario():ari=0:EXIT SUB ' array var assign 
 ELSEIF lxi<48 THEN
  IF (chi>0)AND(chi<9) THEN
   IF (lxi=nxi)AND((nxi=43)OR(nxi=45)) THEN
    ii+=1:ayi=lxi
    IF (qfi=1) THEN 'pre incr decr
     'predec simple vars only
     words():ii=pii:vario()
    END IF
    IF ayi=43 THEN vcd(vfdi)+=1:EXIT SUB
    IF ayi=45 THEN vcd(vfdi)-=1:EXIT SUB
   END IF
   IF nxi=61 THEN ii+=1 ' += -= *= /=
   pqi=opi:opi=chi:qfi=1
   EXIT SUB
  END IF
  IF lxi=40 THEN
   donest():EXIT SUB
  ELSEIF lxi=41 THEN
   IF toki THEN unnest():EXIT SUB 'load time new
   storeval():IF newvi=10 THEN az="":EXIT SUB ' done header
   unnest(): IF wz="" THEN ops(): EXIT SUB
   IF newvi=10 THEN pai=pbi ' for functions called within a header default
   ipa():nui=0:ai=ASC(wz)
   IF ai=IFUNS THEN
    tki=ASC(wz,2):intfun():pai=nei(neni,3):EXIT SUB
   end if
   qai=poi-pai+1: IF noi=2 THEN qai-=1
   IF (ai>FUNBASE)AND(ai<IFUNS) THEN 
    libfuns=tfi(IFUNS-ai)
    funi=ASC(wz,2):libfunction():pai=nei(neni,3):EXIT SUB
   END IF
   neni+=1:callufunction():EXIT SUB
  ELSEIF lxi=44 THEN
   storeval():ipa(): nui=2:clearop()
   IF newvi>0 THEN newvar()
   EXIT SUB
  END IF
 END IF
 IF (nxi=40)OR(nxi=91) THEN
  'could be function or nesting or method
  qpz=wz: IF pti THEN qpz=cat2(".",wz)
  EXIT SUB
 END IF
 varion():ops()
END SUB



SUB libfunction()
 'exit sub
 IF libfuns=0 THEN EXIT SUB
 libfuns( funi, pai ): nui=vsi(0)
 IF nui<>1 THEN bz=vcz(0)
 IF nui=1 THEN vd=vcd(0)
 ops()
END SUB



SUB callufunction()
 if sbi=1 then arz=cat2("Assign statement too complex: ",inlz):errms():inlz="":dfinish():EXIT SUB
 IF ASC(wz)=46 THEN
  wz=MID$(wz,2):namesplit(): gz=eza(ei): vario()
  selfi=-vfdi:wz+=".type":vario():wz=bz+"."+gz
 end if
 efi=1:ddo(): newvi=0:undi=0
 IF fbi=0 THEN unnest():nui=noi:EXIT SUB
 fvi=proci(bi,1):fti=proci(bi,2)
 IF LEN(pz) THEN
  az=pz:ii=2:pz="":newvi=10: nui=2:newvar():clearop()
 end if
END SUB



SUB evarion()
 IF nxi=DUMMY THEN ii+=1:EXIT SUB 'dummy var
 words():IF lwi=0 THEN bz="":vd=0:EXIT SUB
 varion()
END SUB



SUB varion()
 IF qui>0 THEN nui=0: bz=MID$(wz,2,lwi-2):  EXIT SUB
 IF ((lxi>47)AND(lxi<58))OR(lxi=46) THEN
  IF lxi=48 THEN
   IF LCASE$(MID$(wz,1,2))="0x" THEN MID$(wz,1)="&h"
  end if
  IF RIGHT$(wz,1)="E" THEN 
   IF nxi=45 THEN ii+=1: words():wz=cat3(wz,"-",wz)
  end if
  nui=1: vd=VAL(wz): EXIT SUB
 END IF
 IF nxi=61 THEN
  IF newvi=0 THEN
   nui=2:clearop():newvi=4:ii+=1:oz=cat4(oz,";",wz,"=")
   EXIT SUB
  end if
 end if
 vario()
END SUB



SUB clearop()
opi=0:pqi=0:qpz="":qfi=1:accd=0:bcz="":nui=2
END SUB



SUB newvar()
'store variable names
words(): IF lwi=0 THEN EXIT SUB
IF newvi<>10 THEN vsi(pai)=2
IF newvi THEN vaz(pai)=cat2(namz,wz)
IF newvi=0 THEN vaz(pai)=""
IF (nxi=91)AND(newvi=1) THEN
 ii+=1:evarion():words()
 IF (vd+pai)>PARAMAX THEN
  arz=cat3("array elements ",namz,vaz(pai)):toomany()
  EXIT SUB
 end if
 aai=vd:vsi(pai)=1:vcd(pai)=aai
 FOR ai=1 TO aai:vaz(pai+ai)="":vsi(pai+ai)=0:NEXT
 IF nxi<>61 THEN pai=pai+aai:aai=0
END IF
IF nxi=61 THEN ii+=1
IF keyi THEN keyz=cat3(" ",vaz(pai),keyz)
vfdi=pai
END SUB



SUB storeval()
 IF (newvi=10)AND(vsi(pai)<>2)AND(pai<=poi) THEN EXIT SUB
 IF newvi=4 THEN
  IF nui=1 THEN oz=cat2(oz,STR$(vd))
  IF nui=0 THEN oz=cat4(oz,CHR$(34),bz,CHR$(34))
  newvi=0:EXIT SUB
 END IF
 IF aai THEN
  FOR ai=1 TO aai
   pai+=1:vsi(pai)=nui:vcd(pai)=accd:vcz(pai)=bcz
  NEXT
  aai=0:EXIT SUB
 END IF
 vsi(pai)=nui
 IF newvi=0 THEN vaz(pai)=""
 IF nui=2 THEN EXIT SUB
 IF nui=1 THEN vcd(pai)=accd: EXIT SUB
 IF nui=0 THEN vcz(pai)=bcz
END SUB



SUB donest()
 IF neni>=64 THEN
  arz=cat2("Too many left brackets: ",az):errms()
  neni=0:az="":EXIT SUB
 end if
 ned(neni)=accd:nei(neni,0)=nui :nei(neni,1)=opi
 nei(neni,2)=pqi: nei(neni,3)=pai
 nei(neni,4)=pbi: nei(neni,5)=newvi: nez(neni,0)=bcz
 nez(neni,1)=qpz
 IF newvi=10 THEN pai=pbi
 neni+=1: ipa()
 'pqi=0:qpz="":opi=0:nui=2
 newvi=0: clearop()
END SUB



SUB unnest()
 poi=pai
 IF neni<=0 THEN
  arz=cat2("Too many right brackets: ",az):errms()
  neni=0:az="":EXIT SUB
 end if
 neni-=1:vd=accd:bz=bcz:noi=nui:pbi=pai 'max params
 newvi=nei(neni,5)
 IF newvi=10 THEN pbi=nei(neni,4) 'max params
 pai=nei(neni,3):pqi=nei(neni,2):opi=nei(neni,1)
 accd=ned(neni):bcz=nez(neni,0):wz=nez(neni,1)
 IF nei(neni,0)<>2 THEN nui=nei(neni,0)
END SUB



SUB intfun()
 nui=0:fun()
  IF fyni=0 THEN ops(): EXIT SUB
 arz$=cat4("Undefined internal function ",STR$(funi)," ",wz)
 errms():fyni=0
END SUB



SUB ops()
 ei=ERR:ERR=0
 qfi=0

 IF opi=21 THEN 'NOT
  IF nui<>1 THEN vd=LEN(bz):nui=1
  IF vd=0 THEN vd=1 ELSE vd=0
  opi=pqi
 END IF

SELECT CASE AS CONST opi

 ' charz
 CASE 0
  IF nui=1 THEN accd=vd ELSE bcz=bz
 CASE 1
  IF nui=1 THEN accd+=vd ELSE bcz=cat2(bcz,bz)
 CASE 2
  IF nui=1 THEN
   accd-=vd
  ELSE
   bcz=cat2(RTRIM$(bcz),LTRIM$(bz))
  end if
 CASE 3
  IF nui=1 THEN
   accd*=vd 
  ELSE
   bcz=cat2(RTRIM$(bcz),LTRIM$(bz))
  end if
 CASE 4
  IF nui<>1 THEN GOTO opex
  IF vd=0 THEN
   IF neri=0 THEN
    arz=cat4("Divide by zero: ",az," ",STR$(pii))
    errms(): accd=1E30*sgn(accd)
   end if
  ELSE
   accd/=vd
  END IF
 CASE 5
  IF nui=1 THEN
   accd=SGN(accd-vd):IF accd<0 THEN accd=1 ELSE accd=0
  ELSE
   nui=1:accd=0:IF bcz<bz THEN accd=1
  END IF
 CASE 6
  IF nui=1 THEN
   accd=SGN(accd-vd):IF accd>0 THEN accd=1 ELSE accd=0
  ELSE
   nui=1:accd=0:IF (bcz>bz) THEN accd=1
  END IF
 CASE 7 'EQ
  IF nui=1 THEN
   accd=SGN(accd-vd)
   IF accd=0 THEN accd=1 ELSE accd=0
  ELSE
   nui=1: IF bcz=bz THEN accd=1 ELSE accd=0
  END IF
 CASE 8 'NE
  IF nui=1 THEN
   accd=SGN(accd-vd):IF accd<>0 THEN accd=1
  ELSE
   nui=1: IF bcz=bz THEN accd=0 ELSE accd=1
  END IF
 CASE 9
  IF nui=1 THEN
   accd=SGN(accd-vd)
   IF accd>0 THEN accd=0 ELSE accd=1
  ELSE
   nui=1:accd=0:IF bcz<=bz THEN accd=1
  END IF
 CASE 10
  IF nui=1 THEN
   accd=SGN(accd-vd):IF accd<0 THEN accd=0 ELSE accd=1
  ELSE
   nui=1:accd=0:IF bcz>=bz THEN accd=1
  END IF
 CASE 11
  IF nui=1 THEN
   accd=accd-vd:IF accd THEN accd=1 ELSE accd=0
  ELSE
   nui=1:accd=0:IF NOT(bcz=bz) THEN accd=1
  END IF
 CASE 31
  accd=(accd AND vd)
 CASE 32
  accd=accd OR vd
 CASE 33
  accd=accd XOR vd

END SELECT

opex:
 opi=0: ei=ERR: ERR=0
 IF ei THEN
  eri=ei:arz=cat2("Arithmetical error in expression: ",az)
  errms()
 end if
END SUB



'SUB wfun()
' #include "winbinding.inc"
' fyni=1:GOTO fzl



SUB fun()
 SELECT CASE AS CONST tki

 CASE 01:'abs
  nui=1: vd=ABS(vd):EXIT SUB
 CASE 02:'atn
  vd=ATN(vd)*rtdd:nui=1:EXIT SUB
 CASE 03:'atan
  atand():vd=vd*dtrd: EXIT SUB
 CASE 04:'atand
  atand(): EXIT SUB
 CASE 05:'asc
  IF poi=pai THEN vd=1 ELSE bz=vcz(pai)
  nui=1:bi=1: IF bi<vd THEN bi=vd
  IF bi<=LEN(bz) THEN vd=ASC(bz,bi) ELSE vd=0
  EXIT SUB
 CASE 06:'append
  mdz="a": opens():vd=fci:nui=1:EXIT SUB
 CASE 07:'attrib not implemented
  EXIT SUB
  'nui=1:ERR=0
  'vd=GETATTR(bz):erfi=ERR:EXIT SUB
 CASE 08:'chr
  bz=CHR$(vd AND 255):EXIT SUB
 CASE 09:'cos
  vd=COS(vd):nui=1:EXIT SUB
 CASE 10:'cosd
  vd=COS(vd*dtrd):nui=1:EXIT SUB
 CASE 11:'color
  COLOR vcd(pai),vd:EXIT SUB
 CASE 12:'date
  bz=DATE$:EXIT SUB
 CASE 13:'deletefile
  erasef(): EXIT SUB
 CASE 14:'directory
  bz=CURDIR$():EXIT SUB
 CASE 15:'cls
  CLS:EXIT SUB
CASE 16:'dir
  ERR=0
  IF LEN(vcz(pai)) THEN bz=DIR$(vcz(pai),vd) ELSE bz=DIR$
  EXIT SUB
 CASE 17:'eof
  nui=1: fci=vd: vd=0:IF EOF(fci) THEN vd=1
  EXIT SUB
 CASE 18:'environ
  bz=ENVIRON$(bz):EXIT SUB
 CASE 19:'error
  bz=irrmz:irrmz="":EXIT SUB
 CASE 20:'file
  fci=vcd(pai):mdz="b": ffz=bz: oopen(): vd=fci:nui=1
  EXIT SUB
 CASE 21:'fix
  vd=FIX(vd):nui=1:EXIT SUB
 CASE 22:'frac
  vd=vd-INT(vd):nui=1:EXIT SUB
 CASE 23:'get
  getr(): EXIT SUB
 CASE 24:'hex
  bz=HEX$(vd)
  bz=cat2(STRING$(IIF(LEN(bz)>2,0,2-LEN(bz)),"0"),bz)
  EXIT SUB
 CASE 25:'in
  bz="":fci=vd:LINE INPUT #fci,bz: EXIT SUB
 CASE 26:'input
  openin(): vd=fci: nui=1: EXIT SUB
 CASE 27:'int
  vd=INT(vd):nui=1:EXIT SUB
 CASE 28:'lower
  bz=LCASE$(bz):EXIT SUB
 CASE 29:'len
  vd=LEN(bz):nui=1:EXIT SUB
 CASE 30:'lof
  fci=vd:lenfd=LOF(fci):vd=lenfd:nui=1:EXIT SUB
 CASE 31:'log
  vd=LOG(vd):nui=1:EXIT SUB
 CASE 32:'lock
  lockr():EXIT SUB
 CASE 33:'getkey
  bz=Inkey$:EXIT SUB
 CASE 34:'mod (floating point)
  nui=1
  if vd=0 then exit sub ' gen error?
  IF poi=pai THEN vd=accd-int(accd/vd)*vd:pqi=0:opi=0:EXIT SUB
  ud=vcd(pai): vd=ud-int(ud/vd)*vd: EXIT SUB
 CASE 35:'midl
  IF vd<=0 THEN vd+=len(vcz(pai))+1
  vd-=vcd(pai+1)
  GOTO fmid
 CASE 36:'mid
 fmid:
  IF poi-pai=1 THEN vd=32767
  ai=LEN(vcz(pai)):bi=vcd(pai+1):ci=vd
  IF ci<-32767 THEN ci=-32767
  IF ci>32767 THEN ci=32767
  IF ci<0 THEN ci+=ai
  IF bi<0 THEN bi+=ai-ci+2 'offset from the right
  IF bi<1 THEN bi=1
  bz=MID$(vcz(pai),bi,ci):EXIT SUB
 CASE 37:'min
  ud=(vcd(pai)):nui=1:vd=IIF(vd>ud,ud,vd):EXIT SUB
 CASE 38:'max
  ud=(vcd(pai)):nui=1:vd=IIF(vd<ud,ud,vd):EXIT SUB
 CASE 39:'minmax
  ud=(vcd(pai)):wd=(vcd(pai+1)):nui=1
  wd=IIF(wd<ud,ud,wd):wd=IIF(wd>vd,vd,wd):vd=wd:EXIT SUB
 CASE 40:'not used
  EXIT SUB
 CASE 41:'num
  if noi=0 then EXIT SUB 'default returns string
  IF poi>pai THEN 
   ai=val(vcz(pai))
  else
   ai=val(numf):if len(numf)=0 then bz=STR$(vd):EXIT SUB
  end if
  bz=str$(int(abs(vd)*10^ai+.5))
  if len(bz)<ai then bz=string$(ai-len(bz),"0")+bz
  if ai then bz=left$(bz,len(bz)-ai)+"."+right$(bz,ai)
  if sgn(vd)<0 then bz="-"+bz
  ' to provid own formatting according to bz or make vb compat
  EXIT SUB
 CASE 42:'numbers
  numf=vcz(pai):bz=""
  EXIT SUB
 CASE 43:'close
  fci=vd:cloose()
  EXIT SUB
 CASE 44:'out
  vd=vcd(pai): if vd<>0 then pri=vd
  fci=vd:prynt(): nui=1:vd=0
  EXIT SUB
 CASE 45:'output
  mdz="o": opens():vd=fci:nui=1:EXIT SUB
 CASE 46:'unused
  EXIT SUB
CASE 47:'read
  ai=poi-pai: IF ai=0 THEN vcz(pai)=bz
  IF ai>0 THEN vd=vcd(pai+1) ELSE vd=1
  IF ai>1 THEN cnarz=vcz(pai+2) ELSE cnarz=""
  wtz=vcz(pai):vcd(2)=vd
  FOR ai=1 TO 5:vsi(ai)=1:NEXT
  nui=1:EXIT SUB
 CASE 48:'params
  nui=1:vd=qai:EXIT SUB
 CASE 49:'pos
  IF poi-pai<2 THEN vd=1
  nui=1:vd=INSTR(vd,vcz(pai),vcz(pai+1)):EXIT SUB
 CASE 50:'quest
  line input bz,bz:EXIT SUB
 CASE 51:'put
  putr():EXIT SUB
 CASE 52:'power
  nui=1
  IF pai=poi THEN pqi=0:opi=0:vd=accd ^ vd:EXIT SUB
  vd=vcd(pai)^vd:EXIT SUB
 CASE 53:'pyth
  nui=1:wd=0
  FOR ai=pai+1 TO poi-1: wd=wd+(vcd(ai)^2): NEXT
  vd=SQR( vcd(pai)^2+(wd*SGN(vd))  ): EXIT SUB
 CASE 54:'prepos
  nui=1:ai=1
  IF poi-pai<2 THEN li=LEN(vcz(pai+1)) ELSE li=vd
  WHILE vd>0
   IF MID$(vcz(pai),vd,li)=vcz(pai+1) THEN EXIT WHILE
   vd-=1
  WEND
  EXIT SUB
 CASE 55:'range
  pd=(vcd(pai+0)):qd=(vcd(pai+1)):rd=vd:nui=1:vd=0
  IF (pd<=qd)AND(qd<=rd) THEN vd=1
  EXIT SUB
 CASE 56:'many
  ' characters only
  cz=vcz(pai): ci=LEN(cz)
  bz=STRING$(vd*ci,cz): IF ci<2 THEN EXIT SUB
  FOR ai=1 to LEN(bz) STEP ci:MID$(bz,ai)=cz:NEXT
  EXIT SUB
 CASE 57:'replace
  ' provide own routine
  ai=1:cz=vcz(pai+1):dz=bz:bz=vcz(pai)
  IF cz="" THEN EXIT SUB
  DO
   ai=INSTR(ai,bz,cz): IF ai=0 THEN EXIT DO
   bz=LEFT$(bz,ai-1)+dz+MID$(bz,ai+LEN(cz)):ai+=len(dz)
  LOOP
  EXIT SUB
  'bz=vcz(pai): REPLACE vcz(pai+1) WITH vcz(pai+2) IN bz
  EXIT SUB
 CASE 58:'randomize
  RANDOMIZE vd:EXIT SUB
  CASE 59:'random
  vd=RND(vd):nui=1:EXIT SUB
 CASE 60:'round
  ' own routine
  vd=int(vcd(pai)*10^vd+.5)/(10^vd):nui=1
  EXIT SUB
  'vd=ROUND( (vcd(pai)), vd ):nui=1:EXIT SUB
 CASE 61:'resources
  bz=cat3(cat4("lines=",STR$(prgeni)," functions=",_
  STR$(prci)),cat4(" variables=",STR$(pai)," nesting=",_
  STR$(neni)),cat4(" funstack=",STR$(prgseli)," blocks=",_
  str$(bli)))
  EXIT SUB
 CASE 62:'str
 IF noi=1 THEN bz=STR$(vd)
  EXIT SUB
 CASE 63:'seek
  seekr(): EXIT SUB
 CASE 64:' exp
  nui=1:vd=EXP(vd):EXIT SUB
 CASE 65:'sgn
  nui=1: vd=SGN(vd):EXIT SUB
 CASE 66:'unused
  EXIT SUB
 CASE 67:'unused
  EXIT SUB
 CASE 68:'sin
  vd=SIN(vd):nui=1:EXIT SUB
 CASE 69:'sind
  vd=SIN(vd*dtrd):nui=1:EXIT SUB
 CASE 70:'sort
  ' own routine
  EXIT SUB
 CASE 71:'tan
  nui=1:vd=TAN(vd):EXIT SUB
 CASE 72:'tand
  nui=1:vd=TAN(vd*dtrd):EXIT SUB
 CASE 73:'trim
  bz=LTRIM$(RTRIM$(bz)):EXIT SUB
 CASE 74:'time
  bz=TIME$:EXIT SUB
 CASE 75:'timer
  nui=1:vd=TIMER:EXIT SUB
 CASE 76:'type
  neri=1:wz=bz:vario():vd=nui:nui=1:neri=0:EXIT SUB
 CASE 77:'upper
  bz=UCASE$(bz):EXIT SUB
 CASE 78:'unlock
  unlockr():EXIT SUB
 CASE 79:'getmouse
  GETMOUSE gm1,gm2,gm3,gm4
  vcd(12)=gm1:vsi(12)=1
  vcd(13)=gm2:vsi(13)=1
  vcd(14)=gm3:vsi(14)=1
  vcd(15)=gm4:vsi(15)=1
  EXIT SUB
 CASE 80:'val
  IF noi<>1 THEN
   IF MID$(bz,1,2)="0x" THEN MID$(bz,1)="&h"
   vd=VAL(bz)
  END IF
  nui=1: EXIT SUB
 CASE 81:'locate
  LOCATE vcd(pai),vcd(pai+1),vd:EXIT SUB
 CASE 82:'version
  bz="070300": EXIT SUB
 CASE 83:'word
  wordsf():EXIT SUB
 CASE 84: 'chdir
  CHDIR bz:EXIT SUB
 CASE 85: 'mkdir
  MKDIR bz:EXIT SUB
 CASE 86: 'rmdir
  RMDIR bz:EXIT SUB
 CASE 87: 'shell
  SHELL bz:EXIT SUB
 
 END SELECT

 fzl:
 fyni=1
END SUB



SUB wordsf()
 IF LEN(cnarz) THEN pari=1
 haz=az:hai=ii: ii=vcd(2):IF ii<1 THEN ii=1
 az=wtz:words():bz=wz
 wz="":vcd(1)=swdi: vcd(2)=ii:vcd(3)=lwi
 vcd(4)=lxi:vcd(5)=nxi
 az=haz: ii=hai: nui=0:pari=0: vsi(1)=1:vsi(2)=1
END SUB



SUB atand() ' 360 deg tan
 nui=1
 wd=(vcd(pai))
 IF pai=poi THEN ud=1 ELSE ud=(vcd(pai+1))
 IF ud=0 THEN
  vd=90*SGN(wd)
  IF vd=-90 THEN vd=270
 ELSEIF wd=0 THEN
  IF ud<0 THEN vd=180 ELSE vd=0
 ELSE
  vd=ATN(ABS(wd/ud))*rtdd
  IF (wd<0)AND(ud<0) THEN vd=vd+180: EXIT SUB
  IF wd<0 THEN vd=360-vd
  IF ud<0 THEN vd=180-vd
 END IF
END SUB



SUB erasef()
 ERR=0
 KILL vcz(pai)
 vd=ERR
END SUB



SUB ipa:
 IF pai<paramax THEN pai+=1: EXIT SUB 
 arz="Too many vars or params in queue":errms()
 dfinish():EXIT SUB
END SUB



SUB dpa()
 IF pai>26 THEN pai-=1
END SUB



SUB errms()
 irrmz=cat3(arz," at "+mid$(mrk,2)+" in ",proz)
 print irrmz
 IF LEN(logfz)>0 THEN PRINT #logi, irrmz
 IF ermx>=0 THEN
  erci+=1
  IF erci>ermx then
   PRINT #logi,cat3("Termination with ",STR$(erci)," errors")
   dfinish()
  end if
 end if
 ERR=0
END SUB



SUB seekr()
ai=vcd(pai)
ERR=0
SEEK #ai,vd
vd=ERR:nui=1
END SUB



SUB getr()
ai=vcd(pai)
ERR=0
ud=lof(ai)-loc(ai): if ud<vd then vd=ud
bz=string$(vd,chr$(0))
GET$ #ai,,bz
vcz(10)=STR$(ERR):vsi(10)=1
END SUB



SUB lockr()
ai=vcd(pai)
ERR=0
LOCK #ai,(vcd(pai+1)) TO vcd(pai+2)
vd=ERR: nui=1
END SUB



SUB unlockr()
ai=vcd(pai)
ERR=0
UNLOCK #ai,(vcd(pai+1)) TO vcd(pai+2)
vd=ERR: nui=1
END SUB



SUB putr()
ai=vcd(pai)
ERR=0
PUT$ #ai,,bz
vd=ERR: nui=1
END SUB



SUB oopen()
vd=0:fz=ffz:fci=FREEFILE
lenfd=0:erfi=0:IF fz="" THEN atti=0:EXIT SUB
ERR=0:opn():erfi=ERR:IF erfi THEN cloose()
ffz=fz:noermi=0
END SUB



SUB opn()
ERR=0
IF mdz="o" THEN
 atti=0
ELSE
 IF mdz="b" THEN OPEN fz FOR BINARY AS #fci:CLOSE #fci 'auto create
 atti=0
 'atti=ATTRIB(fz)
END IF
opnr:
'tti=(atti AND 1)+vd ' write protection todo
IF mdz="b" THEN
 ' r/w except when field locking and filesafety
 IF tti THEN
  OPEN fz FOR BINARY ACCESS READ AS #fci
 ELSE
  OPEN fz FOR BINARY AS #fci
 END IF
END IF
IF mdz="i" THEN
 OPEN fz FOR INPUT AS #fci
END IF
IF (mdz="o")OR(mdz="a") THEN
 IF (atti AND 1) THEN
  erfi=1
 ELSE
  IF mdz="o" THEN OPEN fz FOR OUTPUT AS #fci
  IF mdz="a" THEN OPEN fz FOR APPEND AS #fci
 END IF
END IF
END SUB



SUB cloose()
if pri=fci then pri=0
IF fci THEN CLOSE(fci):fci=0
END SUB


'end prog
